/** 修改版本号 webpack 插件 */
function ModifyVersionPlugin(newVersion) {
  this.newVersion = newVersion;
}

ModifyVersionPlugin.prototype.apply = function(compiler) {
  compiler.hooks.emit.tap('ModifyVersionPlugin', function(compilation) {
    let assets = compilation.assets;
    let fileNames = Object.keys(assets);
    let version = this.newVersion;
    // 此项可以根据情况开启，用来更新源码中静态变量的值为当前版本号
    // 示例： const __VERSION__ = '__package_version__'
    // 打包后 __VERSION__  变量的值将变为当前版本号
    // fileNames.forEach(function(fileName) {
    //   if (fileName === 'index.js') {
    //     let asset = assets[fileName];
    //     let assetSource = asset.source();
    //     // 将代码中的 __package_version__ 变量替换为版本号
    //     let updatedSource = assetSource.replace(/__package_version__/, version);
    //     asset.source = function() {
    //       return updatedSource;
    //     };
    //   }
    // });

    // 修改 /dist/package.json 中的版本号
    try {
      const file = './package.json';
      const fs = require('fs');
      let json = JSON.parse(fs.readFileSync(file, 'utf8'));
      json.version = version;
      fs.writeFileSync(file, JSON.stringify(json, null, 2));
    } catch (e) {
      console.error(e)
    }
  }.bind(this));
};

module.exports = ModifyVersionPlugin;
